// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from novatel_gps_msgs:msg/NovatelPsrdop2.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/novatel_psrdop2__rosidl_typesupport_fastrtps_cpp.hpp"
#include "novatel_gps_msgs/msg/detail/novatel_psrdop2__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace std_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const std_msgs::msg::Header &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  std_msgs::msg::Header &);
size_t get_serialized_size(
  const std_msgs::msg::Header &,
  size_t current_alignment);
size_t
max_serialized_size_Header(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace std_msgs

namespace novatel_gps_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const novatel_gps_msgs::msg::NovatelMessageHeader &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  novatel_gps_msgs::msg::NovatelMessageHeader &);
size_t get_serialized_size(
  const novatel_gps_msgs::msg::NovatelMessageHeader &,
  size_t current_alignment);
size_t
max_serialized_size_NovatelMessageHeader(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace novatel_gps_msgs

namespace novatel_gps_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const novatel_gps_msgs::msg::NovatelPsrdop2System &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  novatel_gps_msgs::msg::NovatelPsrdop2System &);
size_t get_serialized_size(
  const novatel_gps_msgs::msg::NovatelPsrdop2System &,
  size_t current_alignment);
size_t
max_serialized_size_NovatelPsrdop2System(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace novatel_gps_msgs


namespace novatel_gps_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
cdr_serialize(
  const novatel_gps_msgs::msg::NovatelPsrdop2 & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.header,
    cdr);
  // Member: novatel_msg_header
  novatel_gps_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.novatel_msg_header,
    cdr);
  // Member: gdop
  cdr << ros_message.gdop;
  // Member: pdop
  cdr << ros_message.pdop;
  // Member: hdop
  cdr << ros_message.hdop;
  // Member: vdop
  cdr << ros_message.vdop;
  // Member: systems
  {
    size_t size = ros_message.systems.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      novatel_gps_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.systems[i],
        cdr);
    }
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  novatel_gps_msgs::msg::NovatelPsrdop2 & ros_message)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.header);

  // Member: novatel_msg_header
  novatel_gps_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.novatel_msg_header);

  // Member: gdop
  cdr >> ros_message.gdop;

  // Member: pdop
  cdr >> ros_message.pdop;

  // Member: hdop
  cdr >> ros_message.hdop;

  // Member: vdop
  cdr >> ros_message.vdop;

  // Member: systems
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.systems.resize(size);
    for (size_t i = 0; i < size; i++) {
      novatel_gps_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.systems[i]);
    }
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
get_serialized_size(
  const novatel_gps_msgs::msg::NovatelPsrdop2 & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: header

  current_alignment +=
    std_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.header, current_alignment);
  // Member: novatel_msg_header

  current_alignment +=
    novatel_gps_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.novatel_msg_header, current_alignment);
  // Member: gdop
  {
    size_t item_size = sizeof(ros_message.gdop);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: pdop
  {
    size_t item_size = sizeof(ros_message.pdop);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: hdop
  {
    size_t item_size = sizeof(ros_message.hdop);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: vdop
  {
    size_t item_size = sizeof(ros_message.vdop);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: systems
  {
    size_t array_size = ros_message.systems.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        novatel_gps_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.systems[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
max_serialized_size_NovatelPsrdop2(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: header
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        std_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Header(
        full_bounded, current_alignment);
    }
  }

  // Member: novatel_msg_header
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        novatel_gps_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_NovatelMessageHeader(
        full_bounded, current_alignment);
    }
  }

  // Member: gdop
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: pdop
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: hdop
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: vdop
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: systems
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        novatel_gps_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_NovatelPsrdop2System(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _NovatelPsrdop2__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const novatel_gps_msgs::msg::NovatelPsrdop2 *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _NovatelPsrdop2__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<novatel_gps_msgs::msg::NovatelPsrdop2 *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _NovatelPsrdop2__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const novatel_gps_msgs::msg::NovatelPsrdop2 *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _NovatelPsrdop2__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_NovatelPsrdop2(full_bounded, 0);
}

static message_type_support_callbacks_t _NovatelPsrdop2__callbacks = {
  "novatel_gps_msgs::msg",
  "NovatelPsrdop2",
  _NovatelPsrdop2__cdr_serialize,
  _NovatelPsrdop2__cdr_deserialize,
  _NovatelPsrdop2__get_serialized_size,
  _NovatelPsrdop2__max_serialized_size
};

static rosidl_message_type_support_t _NovatelPsrdop2__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_NovatelPsrdop2__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace novatel_gps_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_novatel_gps_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<novatel_gps_msgs::msg::NovatelPsrdop2>()
{
  return &novatel_gps_msgs::msg::typesupport_fastrtps_cpp::_NovatelPsrdop2__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, novatel_gps_msgs, msg, NovatelPsrdop2)() {
  return &novatel_gps_msgs::msg::typesupport_fastrtps_cpp::_NovatelPsrdop2__handle;
}

#ifdef __cplusplus
}
#endif
